/************************************************************
 * PrintAccounts.java
 * 
 *    ¸ ϴ α׷
 * Account ߻ Ŭӿ .
 ************************************************************/

import java.util.Formatter;

/**
 *  ¸ Ÿ Ŭ Account.
 *  ȣ accId ܾ balance  ϰ ִ.
 * Account ߻ Ŭ̹Ƿ   ü   .
 */
abstract class Account
{
    protected static int serialAccId = 0;
    protected int accId;
    protected double balance;

    public Account() 
    {
        accId = ++serialAccId;
        balance = 0;
    }
    public String toString() 
    {
        return "Account" + accInfo();
    }
    protected String accInfo()
    {
        return "("+accId+": "+balance+")";
    }
}

/**
 * Account Ŭ SavingsAccount.
 * SavingsAccount   ¸ Ÿ.
 */
class SavingsAccount extends Account
{
    public SavingsAccount()
    {
        super();
    }
    public String toString()
    {
        return "Savings" + accInfo();
    }
}

/**
 * Account Ŭ CheckingAccount.
 * CheckingAccount   ¸ Ÿ.
 */
class CheckingAccount extends Account
{
    public CheckingAccount()
    {
        super();
    }
    public String toString()
    {
        return "Checking" + accInfo();
    }
}

/**
 * CheckingAccount Ŭ LoanAccount.
 * LoanAccount ̳ʽ  Ÿ.
 */
class LoanAccount extends CheckingAccount
{
    public static final double defaultAPR = 0.2;
    protected double loanAPR = defaultAPR;
    protected double loanLimit;

    public LoanAccount(double limit)
    {
        super();
        loanLimit = limit;
    }
    protected String loanInfo()
    {
        Formatter buf = new Formatter();
        buf.format("[Loan Limit: %d, APR: %.1f%%]", (int)loanLimit, loanAPR * 100);
        return buf.toString();
    }
    public String toString()
    {
        String basicInfo = "LoanAccount" + accInfo();
        return basicInfo + loanInfo();
    }
}

/**
 *   ü Ͽ ϱ  PrintAccounts Ŭ.
 * Account ü, SavingsAccount ü, CheckingAccount ü,
 * LoanAccount ü   迭 Ͽ óѴ.
 */
public class PrintAccounts 
{
    public static void main(String args[]) 
    {
        Account accounts[] = {
                new SavingsAccount(), 
                new CheckingAccount(),
                new LoanAccount(1000)};
        for (Account account : accounts) {
            System.out.println(account.toString());
        }
    }
}
