/************************************************************
 * Philosopher.java
 * 
 * Ļϴ ö α׷(¸ ȸϴ ).
 * ũ   Ͽ ¸ ȸѴ.
 ************************************************************/

/**
 * Ļϴ öڸ  Philosopher Ŭ. 
 * ڿ  οϿ ¸ ȸϵ Ͽ.
 *   ũ  µ,  öڸ  ũ   Ͽ.
 * ᱹ  ȣ ũ   μ ¸ ذϿ.
 * ڿ  ο ʾ  NUM_OF_GUESTS == 2, 
 * BOWL_SIZE == 5000000  ¿ , 
 *  α׷ ¿  ʴ´.
 */
public class Philosopher extends Thread 
{
    public static final int NUM_OF_GUESTS = 2;
    public static final int BOWL_SIZE = 5000000;
    private String name;
    private Spaghetti bowl;
    private int scoops = 0;
    private Fork leftFork, rightFork;
    public Philosopher(String name, Spaghetti bowl, Fork left, Fork right) 
    {
        this.name = name;
        this.bowl = bowl;
        leftFork = left;
        rightFork = right;
    }
    public void printName()
    {
        System.out.println(name);
    }
    public synchronized void getForks()
    {
        leftFork.lock();
        rightFork.lock();
    }
    public synchronized void releaseForks()
    {
        leftFork.unlock();
        rightFork.unlock();
    }
    public void eat()
    {
        getForks();
        bowl.scoop();
        scoops++;
        print();
        releaseForks();
    }
    public void print()
    {
        System.out.printf("%s: %d ũ %n", name, scoops);
    }
    public void finalPrint()
    {
        System.out.print("... ");
        print();
    }
    public void run()
    {
        while (! bowl.isEmpty())
            eat();
    }
    public static void main(String args[])
    {
        Philosopher guest[] = new Philosopher[NUM_OF_GUESTS];
        Fork fork[] = new Fork[NUM_OF_GUESTS+1];
        Spaghetti bowl[] = new Spaghetti[NUM_OF_GUESTS];
        String names[] = {"Ȳ", "", "", "", ""};
        for (int i = 0; i < NUM_OF_GUESTS; ++i) {
            fork[i] = new Fork();
            bowl[i] = new Spaghetti(BOWL_SIZE);
        }
        fork[NUM_OF_GUESTS] = fork[0]; 
        for (int i = 0; i < NUM_OF_GUESTS; ++i) {
            int left = i;
            int right = i+1;
            if (i == NUM_OF_GUESTS-1) {
                right = i;
                left = i+1;
            }
            guest[i] = new Philosopher(names[i], bowl[i], fork[left], fork[right]);
            guest[i].start();
        }
        for (int i = 0; i < NUM_OF_GUESTS; ++i) {
            try {
                guest[i].join();
                guest[i].finalPrint();
            } catch (InterruptedException e) {
                System.out.println("Philosopher.main(): ڿ  ߴܵ");
            }
        }
        System.out.println("*** Ļ  ***");
    }
}

/**
 * Ļ   Fork Ŭ. 
 * ũ öڵ ϱ   lock() ޼ҵ
 * unlock() ޼ҵ带 ؾ Ѵ. Fork Ŭ 
 *   ޼ҵ尡 ȭ ޼ҵ Ǿ ִ.
 */
class Fork
{
    private boolean locked;
    public Fork()
    {
        locked = false;
    }
    public synchronized void lock()
    {
        if (locked) {
            try {
                wait();
            }
            catch (InterruptedException e) {
                System.out.println("ڿ  ߴܵ");
            }
        }
        locked = true;
    }
    public synchronized void unlock()
    {
        locked = false;
        notifyAll();
    }
}

/**
 * öڰ Ļ  Ÿ Spaghetti Ŭ. 
 * İƼ  μ ޾Ƽ Ƽ Ѵ.
 * İƼ  ˻ϴ isEmpty(),
 *   Դ scoop() ޼ҵ带 ϰ ִ.
 */
class Spaghetti
{
    int amount;
    public Spaghetti(int amount)
    {
        assert amount >= 0;
        this.amount = amount;
    }
    public boolean isEmpty()
    {
        return amount == 0;
    }
    public void scoop()
    {
        if (! isEmpty())
            amount--;
    }
}
